﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
/****************************************************************************************
　　　　　　　　　　　　　　　　PLCモデムテストプログラムVer1.0
　　　　　　　　　　　　　　　　（AMIS-49587　評価ボード用）
　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　2010.09.30
　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　H.GURITA
****************************************************************************************/
namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private byte[] sendData1 = new byte[256];
        private byte[] rsvData1 = new byte[256];
        private byte[] sendData2 = new byte[256];
        private byte[] rsvData2 = new byte[256];
        private byte[] bufdata = new byte[256];

        public Form1()
        {
            InitializeComponent();
        }
        //マスター設定側リセットボタンの処理
        private void button1_Click(object sender, EventArgs e)
        {
            timer1.Stop();
            try
            {
                serialPort1.Close();//シリアルポートのバッファクリア
                serialPort1.PortName = textBox1.Text;
                serialPort1.Open();
            }
            catch(Exception)
            {
                MessageBox.Show("シリアルポートエラー!");
            }
            sendData1[0] = 0x02;//STX
            sendData1[1] = 0x03;
            sendData1[2] = 0x21;
            sendData1[3] = 0x24;
            sendData1[4] = 0x00;
            serialPort1.RtsEnable = true;
            try
            {
                rsvData1[0] = (byte)serialPort1.ReadByte();
                rsvData1[1] = (byte)serialPort1.ReadByte();
                rsvData1[2] = (byte)serialPort1.ReadByte();
                rsvData1[3] = (byte)serialPort1.ReadByte();
            }
            catch(TimeoutException)
            {
                serialPort1.RtsEnable = false;
                return;
            }
            textBox2.Text = Convert.ToString(rsvData1[0], 16) + " ";
            textBox2.Text += Convert.ToString(rsvData1[1], 16) + " ";
            textBox2.Text += Convert.ToString(rsvData1[2], 16) + " ";
            textBox2.Text += Convert.ToString(rsvData1[3], 16) + " ";
            Application.DoEvents();
            serialPort1.Write(sendData1, 0, 5);
            Thread.Sleep(10);//10msec wait
            serialPort1.RtsEnable = false;
            timer1.Start();
        }
        //マスター設定側初期設定ボタンの処理
        private void button2_Click(object sender, EventArgs e)
        {
            UInt32 csum;
            timer1.Stop();
            try
            {
                serialPort1.Close();
                serialPort1.PortName = textBox1.Text;
                serialPort1.Open();
            }
            catch (Exception)
            {
                MessageBox.Show("シリアルポートエラー!");
            }
            //初期設定のアドレス以外の値は固定
            //詳細はマニュアルのTable 41. CONFIGURATION PARAMETERSを参照してください
            sendData1[0] = 0x02;//STX
            sendData1[1] = 39;//送信文字の長さ
            sendData1[2] = 0x71;//WriteConfigNew
            sendData1[3] = 0x00;
            sendData1[4] = 0x04;
            sendData1[5] = 0xef;
            sendData1[6] = 0x0f;
            sendData1[7] = (byte)(Convert.ToUInt16(textBox4.Text) & 0x00FF);//アドレス設定
            sendData1[8] = (byte)(Convert.ToUInt16(textBox4.Text) >> 8);
            sendData1[9] = 0x00;
            sendData1[10] = 0x00;
            sendData1[11] = 0x1e;
            sendData1[12] = 0x00;
            sendData1[13] = 0xd0;
            sendData1[14] = 0x02;
            sendData1[15] = 0x60;
            sendData1[16] = 0x54;
            sendData1[17] = 0x00;
            sendData1[18] = 0x00;
            sendData1[19] = 0x00;
            sendData1[20] = 0x00;
            sendData1[21] = 0x00;
            sendData1[22] = 0x00;
            sendData1[23] = 0x00;
            sendData1[24] = 0x00;
            sendData1[25] = 0x00;
            sendData1[26] = 0x00;
            sendData1[27] = 0x4b;
            sendData1[28] = 0x19;
            sendData1[29] = 0xaf;
            sendData1[30] = 0x14;
            sendData1[31] = 0x00;
            sendData1[32] = 0x87;
            sendData1[33] = 0x0f;
            sendData1[34] = 0x01;
            sendData1[35] = 0x0e;
            sendData1[36] = 0x42;
            sendData1[37] = 0x00;
            sendData1[38] = 0x02;
            csum = 0;
            for (int i = 1; i < 39; i++)
            {
                csum += sendData1[i];//チェックサムの計算
            }
            sendData1[39] = (byte)(csum & 0x00FF);
            sendData1[40] = (byte)((csum / 256) & 0x00FF);
            serialPort1.RtsEnable = true;
            try
            {
                rsvData1[0] = (byte)serialPort1.ReadByte();
                rsvData1[1] = (byte)serialPort1.ReadByte();
                rsvData1[2] = (byte)serialPort1.ReadByte();
                rsvData1[3] = (byte)serialPort1.ReadByte();
            }
            catch (TimeoutException)
            {
                serialPort1.RtsEnable = false;
                return;
            }
            textBox2.Text = Convert.ToString(rsvData1[0], 16) + " ";
            textBox2.Text += Convert.ToString(rsvData1[1], 16) + " ";
            textBox2.Text += Convert.ToString(rsvData1[2], 16) + " ";
            textBox2.Text += Convert.ToString(rsvData1[3], 16) + " ";
            Application.DoEvents();
            serialPort1.Write(sendData1, 0, 41);
            Thread.Sleep(10);//10msec wait
            serialPort1.RtsEnable = false;
            timer1.Start();
        }
        //マスター設定側メッセージ送信ボタンの処理
        private void button3_Click(object sender, EventArgs e)
        {
            UInt32 csum;
            timer1.Stop();
            bufdata = Encoding.ASCII.GetBytes(textBox5.Text);
            if (bufdata.Length > 16)
            {
                textBox5.Text = "Error !";
                return;
            }
            try
            {
                serialPort1.Close();
                serialPort1.PortName = textBox1.Text;
                serialPort1.Open();
            }
            catch (Exception)
            {
                MessageBox.Show("シリアルポートエラー!");
            }
            //送信用メッセージ（半角英数字）
            sendData1[0] = 0x02;//STX
            sendData1[1] = (byte)(bufdata.Length + 8);
            sendData1[2] = 0x51;
            sendData1[3] = 0x00;
            sendData1[4] = (byte)(Convert.ToUInt16(textBox4.Text) >> 4);
            sendData1[5] = (byte)((Convert.ToUInt16(textBox4.Text) << 4) + (Convert.ToUInt16(textBox6.Text) >> 8));
            sendData1[6] = (byte)(Convert.ToUInt16(textBox6.Text) & 0x00FF);
            sendData1[7] = 0x00;
            for (int i = 0; i < bufdata.Length; i++)
            {
                sendData1[8 + i] = bufdata[i];//送信するデータ
            }
            csum = 0;
            for (int i = 1; i < bufdata.Length + 8; i++)
            {
                csum += sendData1[i];//チェックサムの計算
            }
            sendData1[bufdata.Length + 8] = (byte)(csum & 0x00FF);
            sendData1[bufdata.Length + 9] = (byte)((csum / 256) & 0x00FF);
            serialPort1.RtsEnable = true;
            try
            {
                rsvData1[0] = (byte)serialPort1.ReadByte();
                rsvData1[1] = (byte)serialPort1.ReadByte();
                rsvData1[2] = (byte)serialPort1.ReadByte();
                rsvData1[3] = (byte)serialPort1.ReadByte();
            }
            catch (TimeoutException)
            {
                serialPort1.RtsEnable = false;
                return;
            }
            textBox2.Text = Convert.ToString(rsvData1[0], 16) + " ";
            textBox2.Text += Convert.ToString(rsvData1[1], 16) + " ";
            textBox2.Text += Convert.ToString(rsvData1[2], 16) + " ";
            textBox2.Text += Convert.ToString(rsvData1[3], 16) + " ";
            Application.DoEvents();
            serialPort1.Write(sendData1, 0, bufdata.Length + 10);
            Thread.Sleep(10);//10msec wait
            serialPort1.RtsEnable = false;
            timer1.Start();
        }
        //スレーブ設定側リセットボタンの処理
        private void button6_Click(object sender, EventArgs e)
        {
            timer2.Stop();
            try
            {
                serialPort2.Close();
                serialPort2.PortName = textBox12.Text;
                serialPort2.Open();
            }
            catch (Exception)
            {
                MessageBox.Show("シリアルポートエラー!");
            }
            sendData2[0] = 0x02;//STX
            sendData2[1] = 0x03;
            sendData2[2] = 0x21;
            sendData2[3] = 0x24;
            sendData2[4] = 0x00;
            serialPort2.RtsEnable = true;
            try
            {
                rsvData2[0] = (byte)serialPort2.ReadByte();
                rsvData2[1] = (byte)serialPort2.ReadByte();
                rsvData2[2] = (byte)serialPort2.ReadByte();
                rsvData2[3] = (byte)serialPort2.ReadByte();
            }
            catch (TimeoutException)
            {
                serialPort2.RtsEnable = false;
                return;
            }
            textBox11.Text = Convert.ToString(rsvData2[0], 16) + " ";
            textBox11.Text += Convert.ToString(rsvData2[1], 16) + " ";
            textBox11.Text += Convert.ToString(rsvData2[2], 16) + " ";
            textBox11.Text += Convert.ToString(rsvData2[3], 16) + " ";
            Application.DoEvents();
            serialPort2.Write(sendData2, 0, 5);
            Thread.Sleep(10);//10msec wait
            serialPort2.RtsEnable = false;
            timer2.Start();
        }
        //スレーブ設定側初期設定ボタンの処理
        private void button5_Click(object sender, EventArgs e)
        {
            UInt32 csum2;
            timer2.Stop();
            try
            {
                serialPort2.Close();
                serialPort2.PortName = textBox12.Text;
                serialPort2.Open();
            }
            catch (Exception)
            {
                MessageBox.Show("シリアルポートエラー!");
            }
            sendData2[0] = 0x02;//STX
            sendData2[1] = 39;//Length
            sendData2[2] = 0x71;//WriteConfigNew
            sendData2[3] = 0x00;
            sendData2[4] = 0x04;
            sendData2[5] = 0xef;
            sendData2[6] = 0x0f;
            sendData2[7] = (byte)(Convert.ToUInt16(textBox9.Text) & 0x00FF);
            sendData2[8] = (byte)(Convert.ToUInt16(textBox9.Text) >> 8);
            sendData2[9] = 0x55;
            sendData2[10] = 0x05;
            sendData2[11] = 0x1e;
            sendData2[12] = 0x00;
            sendData2[13] = 0xd0;
            sendData2[14] = 0x02;
            sendData2[15] = 0x60;
            sendData2[16] = 0x54;
            sendData2[17] = 0x00;
            sendData2[18] = 0x00;
            sendData2[19] = 0x00;
            sendData2[20] = 0x00;
            sendData2[21] = 0x00;
            sendData2[22] = 0x00;
            sendData2[23] = 0x00;
            sendData2[24] = 0x00;
            sendData2[25] = 0x00;
            sendData2[26] = 0x00;
            sendData2[27] = 0x4b;
            sendData2[28] = 0x19;
            sendData2[29] = 0xaf;
            sendData2[30] = 0x14;
            sendData2[31] = 0x00;
            sendData2[32] = 0x87;
            sendData2[33] = 0x17;
            sendData2[34] = 0x01;
            sendData2[35] = 0x0e;
            sendData2[36] = 0x42;
            sendData2[37] = 0x00;
            sendData2[38] = 0x02;
            csum2 = 0;
            for (int i = 1; i < 39; i++)
            {
                csum2 += sendData2[i];
            }
            sendData2[39] = (byte)(csum2 & 0x00FF);
            sendData2[40] = (byte)((csum2 / 256) & 0x00FF);
            serialPort2.RtsEnable = true;
            try
            {
                rsvData2[0] = (byte)serialPort2.ReadByte();
                rsvData2[1] = (byte)serialPort2.ReadByte();
                rsvData2[2] = (byte)serialPort2.ReadByte();
                rsvData2[3] = (byte)serialPort2.ReadByte();
            }
            catch (TimeoutException)
            {
                serialPort2.RtsEnable = false;
                return;
            }
            textBox11.Text = Convert.ToString(rsvData2[0], 16) + " ";
            textBox11.Text += Convert.ToString(rsvData2[1], 16) + " ";
            textBox11.Text += Convert.ToString(rsvData2[2], 16) + " ";
            textBox11.Text += Convert.ToString(rsvData2[3], 16) + " ";
            Application.DoEvents();
            serialPort2.Write(sendData2, 0, 41);
            Thread.Sleep(10);//10msec wait
            serialPort2.RtsEnable = false;
            timer2.Start();
        }
        //スレーブ設定側メッセージ送信ボタンの処理
        private void button4_Click(object sender, EventArgs e)
        {
            UInt32 csum;
            timer2.Stop();
            bufdata = Encoding.ASCII.GetBytes(textBox8.Text);
            if (bufdata.Length > 16)
            {
                textBox8.Text = "Error !";
                return;
            }
            try
            {
                serialPort2.Close();
                serialPort2.PortName = textBox12.Text;
                serialPort2.Open();
            }
            catch (Exception)
            {
                MessageBox.Show("シリアルポートエラー!");
            }
            sendData2[0] = 0x02;//STX
            sendData2[1] = (byte)(bufdata.Length + 8);
            sendData2[2] = 0x51;
            sendData2[3] = 0x00;
            sendData2[4] = (byte)(Convert.ToUInt16(textBox9.Text) >> 4);
            sendData2[5] = (byte)((Convert.ToUInt16(textBox9.Text) << 4) + (Convert.ToUInt16(textBox7.Text) >> 8));
            sendData2[6] = (byte)(Convert.ToUInt16(textBox7.Text) & 0x00FF);
            sendData2[7] = 0x00;
            for (int i = 0; i < bufdata.Length; i++)
            {
                sendData2[8 + i] = bufdata[i];//data
            }
            csum = 0;
            for (int i = 1; i < bufdata.Length + 8; i++)
            {
                csum += sendData2[i];
            }
            sendData2[bufdata.Length + 8] = (byte)(csum & 0x00FF);
            sendData2[bufdata.Length + 9] = (byte)((csum / 256) & 0x00FF);
            serialPort2.RtsEnable = true;
            try
            {
                rsvData2[0] = (byte)serialPort2.ReadByte();
                rsvData2[1] = (byte)serialPort2.ReadByte();
                rsvData2[2] = (byte)serialPort2.ReadByte();
                rsvData2[3] = (byte)serialPort2.ReadByte();
            }
            catch (TimeoutException)
            {
                serialPort2.RtsEnable = false;
                return;
            }
            textBox11.Text = Convert.ToString(rsvData2[0], 16) + " ";
            textBox11.Text += Convert.ToString(rsvData2[1], 16) + " ";
            textBox11.Text += Convert.ToString(rsvData2[2], 16) + " ";
            textBox11.Text += Convert.ToString(rsvData2[3], 16) + " ";
            Application.DoEvents();
            serialPort2.Write(sendData2, 0, bufdata.Length + 10);
            Thread.Sleep(10);//10msec wait
            serialPort2.RtsEnable = false;
            timer2.Start();
        }
        //マスター設定側でシリアルポートからの受信データをチェックするタイマーイベント
        private void timer1_Tick(object sender, EventArgs e)
        {
            if(serialPort1.BytesToRead !=0)
            {
                rsvData1[0] = (byte)serialPort1.ReadByte();
            }
            else
            {
                return;
            }
            if (rsvData1[0] == 0x02)
            {
                try
                {
                    rsvData1[1] = (byte)serialPort1.ReadByte();
                    for (int i = 0; i < rsvData1[1]; i++)
                    {
                        rsvData1[i + 2] = (byte)serialPort1.ReadByte();
                    }
                }
                catch (TimeoutException)
                {
                }
                textBox3.Text = Convert.ToString(rsvData1[0], 16) + " ";
                textBox3.Text += Convert.ToString(rsvData1[1], 16) + " ";
                for (int j = 0; j < rsvData1[1]; j++)
                {
                    textBox3.Text += Convert.ToString(rsvData1[j + 2], 16) + " ";
                }
            }
            else if (rsvData1[0] == 0x06)//ACK
            {

                textBox2.Text += " ACK";
            }
            else if (rsvData1[0] == 0x15)//NACK
            {

                textBox2.Text += " NACK";
            }
        }
        //スレーブ設定側でシリアルポートからの受信データをチェックするタイマーイベント
        private void timer2_Tick(object sender, EventArgs e)
        {
            if (serialPort2.BytesToRead != 0)
            {
                rsvData2[0] = (byte)serialPort2.ReadByte();
            }
            else
            {
                return;
            }
            if (rsvData2[0] == 0x02)
            {
                try
                {
                    rsvData2[1] = (byte)serialPort2.ReadByte();
                    for (int i = 0; i < rsvData2[1]; i++)
                    {
                        rsvData2[i + 2] = (byte)serialPort2.ReadByte();
                    }
                    textBox10.Text = Convert.ToString(rsvData2[0], 16) + " ";
                    textBox10.Text += Convert.ToString(rsvData2[1], 16) + " ";
                    for (int j = 0; j < rsvData2[1]; j++)
                    {
                        textBox10.Text += Convert.ToString(rsvData2[j + 2], 16) + " ";
                    }
                }
                catch (TimeoutException)
                {
                }
            }
            else if (rsvData2[0] == 0x06)//ACK
            {

                textBox11.Text += " ACK";
            }
            else if (rsvData2[0] == 0x15)//NACK
            {

                textBox11.Text += " NACK";
            }
        }
        //フォームを閉じるときの終了処理
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            timer1.Stop();
            timer2.Stop();
            serialPort1.Close();
            serialPort2.Close();
        }
    }
}
